<?php
	$GLOBALS['localStorage'] = "/www/localstore/";
	//$GLOBALS['localStorage'] = "../localstore/";
	function getLocalFileData($fname) {
		$filecontent = "";
		$iniFile = $GLOBALS['localStorage'] . $fname;
		if (is_file($iniFile)) {
			//Do nothing... File already exists
			$filecontent = file_get_contents($iniFile);
		} else {
			//Try to create
			/*$fh = fopen($iniFile, 'w+');
			fclose($fh);*/
		}
		
		return $filecontent;
	}
	function saveLocalFileData($fname, $data) {
		try {
			if (!is_file($GLOBALS['localStorage'])) {
				mkdir($GLOBALS['localStorage'], 0777);
			}
		} catch (Exception $e) {}
		
		$iniFile = $GLOBALS['localStorage'] . $fname;
		if (is_file($iniFile)) {
			//Do nothing... File already exists
		} else {
			//Try to create
			$fh = fopen($iniFile, 'w+');
			fclose($fh);
			chmod($iniFile, 0777);
		}
		file_put_contents($iniFile,$data);
	}

	function getVesselSettings($postData, $url) {
		$reqName = base64_encode("getVesselSettings");
		$response = getLocalFileData($reqName);
		
		if (strlen($response) > 0) {
			$response = base64_decode($response);
			header('Content-type: application/json');
			$ret = $response;
		} else {
			$context = stream_context_create(array(
				'http' => array(
					'header'  => "Content-Type: application/x-www-form-urlencoded",
					'method'  => 'POST',
					'content' => http_build_query($postData)
				)
			));
			
			$response = file_get_contents($url, false, $context);
			saveLocalFileData($reqName, base64_encode($response));
		
			header('Content-type: application/json');
			if ($response === FALSE){
				//$ret = "ERROR";
				
				$ret = "";
				header($_SERVER['SERVER_PROTOCOL'] . ' 500 Internal Server Error', true, 500);
			} else {
				$ret = $response;
			}
		}
		
		return $ret;
	}
	
	function getVesselConfig($postData, $url) {
		$reqName = base64_encode("getVesselConfig");
		$response = getLocalFileData($reqName);
		
		if (strlen($response) > 0) {
			$response = base64_decode($response);
			header('Content-type: application/json');
			$ret = $response;
		} else {
			$context = stream_context_create(array(
				'http' => array(
					'header'  => "Content-Type: application/x-www-form-urlencoded",
					'method'  => 'GET',
					'content' => http_build_query($postData)
				)
			));
			
			$response = file_get_contents($url . "?" . http_build_query($postData), false, $context);
			saveLocalFileData($reqName, base64_encode($response));
		
			header('Content-type: application/json');
			if ($response === FALSE){
				//$ret = "ERROR";
				
				$ret = "";
				header($_SERVER['SERVER_PROTOCOL'] . ' 500 Internal Server Error', true, 500);
			} else {
				$ret = $response;
			}
		}
		
		return $ret;
	}
	
	function getLoginHeadlines($postData, $url, $reqName, $folderName) {
		try {
			if (!is_file($GLOBALS['localStorage'] . $folderName)) {
				mkdir($GLOBALS['localStorage'] . $folderName, 0777);
			}
		} catch (Exception $e) {}
		
		$reqName = $folderName . "/" . $reqName;
		$response = getLocalFileData($reqName);
		
		if (strlen($response) > 0) {
			$response = base64_decode($response);
			header('Content-type: application/json');
			$ret = $response;
		} else {
			$context = stream_context_create(array(
				'http' => array(
					'header'  => "Content-Type: application/x-www-form-urlencoded",
					'method'  => 'POST',
					'content' => http_build_query($postData)
				)
			));
			
			$response = file_get_contents($url, false, $context);
			if (strlen($response) > 0) {
				saveLocalFileData($reqName, base64_encode($response));
			
				header('Content-type: application/json');
				if ($response === FALSE){
					//$ret = "ERROR";
					
					$ret = "";
					header($_SERVER['SERVER_PROTOCOL'] . ' 500 Internal Server Error', true, 500);
				} else {
					$ret = $response;
				}
			} else {
				$ret = "";
			}
		}
		
		return $ret;
	}
	
	function getUnreadMessages($postData, $url) {
		$reqName = base64_encode("getticker2");
		$response = getLocalFileData($reqName);
		
		$responseArr = explode("[DEL]", base64_decode($response));
		$lastUMCheck = $responseArr[0];
		if (count($responseArr) > 1) {
			$response = $responseArr[1];
		} else {
			$response = "";
		}
		if (strlen($lastUMCheck) > 0) {
			if (date("YmdHis", strtotime("now")) >= $lastUMCheck) {
				$lastUMCheck = "";
				$response = "";
			} else if (date("Ymd", strtotime($lastUMCheck)) > date("Ymd", strtotime("now"))) {
				$lastUMCheck = "";
				$response = "";
			}
		}
		
		//if (strlen($response) > 0) {
		if (strlen($lastUMCheck) > 0) {
			//$response = base64_decode($response);
			header('Content-type: application/json');
			$ret = $response;
		} else {
			$context = stream_context_create(array(
				'http' => array(
					'header'  => "Content-Type: application/x-www-form-urlencoded",
					'method'  => 'POST',
					'content' => http_build_query($postData)
				)
			));
			
			$response = file_get_contents($url . "?" . http_build_query($postData), false, $context);
			saveLocalFileData($reqName, base64_encode(date("YmdHis", strtotime("+30 minutes")) . "[DEL]" . $response));
			//saveLocalFileData($reqName, base64_encode(date("YmdHis", strtotime("+30 seconds")) . "[DEL]" . $response));
		
			header('Content-type: application/json');
			if ($response === FALSE){
				//$ret = "ERROR";
				
				$ret = "";
				header($_SERVER['SERVER_PROTOCOL'] . ' 500 Internal Server Error', true, 500);
			} else {
				$ret = $response;
			}
		}
		
		return $ret;
	}
?>